# Introduction
CeleScope is a collection of bioinfomatics analysis pipelines to process single cell sequencing data generated with Singleron products. These pipelines take paired-end FASTQ files as input and generate output files which can be used for downstream data analysis as well as a summary of QC criteria.

# Documentation

[User guide](./doc/user_guide.md)

# Support
Please use the issue tracker for questions and malfunctions.

# About
CeleScope is currently developed by Singleron Biotechnologies.

[www.singleron.bio](https://www.singleron.bio)

args <- commandArgs(T)

require("reshape2")
require("tidyr")
require("dplyr")
require("Matrix")

my.count1 <- read.table(args[1],h=F)

my.count1$V1 <- as.character(my.count1$V1)
my.count1$gene <- gsub("--C","",my.count1$V1)
my.count1$gene <- gsub("--T","",my.count1$gene)
cells.keep <- my.count1 %>% dplyr::distinct(V2,V3,gene) %>% group_by(V2) %>% dplyr::summarize(count=n()) %>% arrange(desc(count)) %>% .$V2 %>% as.character 

inds <- as.numeric(args[2])
if (length(cells.keep) > inds) {
 cells.keep2 <- head(cells.keep,inds)
}else{ cells.keep2 <- cells.keep}

my.count1 <- my.count1 %>% filter(V2 %in% cells.keep2) %>% droplevels
my.count1$type <- "C"
my.count1[grep("--T",my.count1$V1),]$type <- "T"
my.count2 <- dcast(my.count1,gene+V2+V3 ~ type, value.var = "V4")
my.count2[is.na(my.count2)] <- 0

if(! "C" %in% colnames(my.count2))
{
  my.count2$C <- 0;
}
if (ncol(my.count2) !=5) {
    stop("Error! Please verify the count data frame!\n");
}
my.count2 <- my.count2 %>% arrange(gene,V2,V3,C,T)
my.count2 %>% mutate(type = ifelse(C > 0,"C","T")) -> my.count2 
my.count3 <- my.count2 %>% group_by(gene,type,V2) %>% dplyr::summarize(count=n())
my.count3$gene2 <- paste(my.count3$gene,my.count3$type,sep="--")
my.count3$V2 <- as.factor(my.count3$V2)
my.count3$gene2 <- as.factor(my.count3$gene2)
data.sparse = sparseMatrix(as.integer(my.count3$gene2), as.integer(my.count3$V2), x = my.count3$count)
colnames(data.sparse) = levels(my.count3$V2)
rownames(data.sparse) = levels(my.count3$gene2)
ord <- sort(colSums(data.sparse),decreasing = T)
data.sparse <- data.sparse[,names(ord)]
saveRDS(data.sparse,file=args[3])
outtsv<-paste(args[3],"tsv", sep = ".")
write.table(as.matrix(data.sparse), file = outtsv, sep = "\t", quote = F, row.names = T)

library(vcfR)
library(argparser)

argv <- arg_parser('')
argv <- add_argument(argv, "--vcf", help="vcf file path")
argv <- add_argument(argv, "--out", help="output file path")
argv <- add_argument(argv, "--sample", help="sample name")

argv <- parse_args(argv)

vcf = read.vcfR(argv$vcf, verbose = FALSE)
gt <- extract.gt(vcf)

write.csv(gt, argv$out, quote=FALSE)

library(Seurat)
library(tidyverse)
library(argparser)

argv <- arg_parser('')
argv <- add_argument(argv,"--matrix_dir", help="")
argv <- add_argument(argv,"--outdir", help="")
argv <- add_argument(argv,"--sample", help="")
argv <- add_argument(argv,"--mt_gene_list_file", help="")
argv <- parse_args(argv)

matrix_dir = argv$matrix_dir
outdir = argv$outdir
sample = argv$sample
mt_gene_list_file = argv$mt_gene_list_file

# out
df.out = str_glue("{outdir}/{sample}_mt_UMI.tsv")

mtx = Read10X(matrix_dir)
mt_gene_list = read.table(mt_gene_list_file)[,1]

gene_valid = rownames(mtx)
gene_intersect = intersect(gene_valid, mt_gene_list)
cells = dim(mtx)[2]
mean_UMI = sort(round(rowSums(mtx[gene_intersect,]) / cells,3), decreasing = T)
df = as.data.frame(mean_UMI)
write.table(df, df.out, sep='\t', col.names=NA, quote = F)

library(Seurat)
library(tidyverse)
library(argparse)
library(ggplot2)
library(stringr)
library(dplyr)

parser <- ArgumentParser()
parser$add_argument("--sample",help="sample name", required=TRUE)
parser$add_argument("--rds", help="scRNA rds path", required=TRUE)
parser$add_argument("--VDJ", help='VDJ match_contigs.csv path', required=TRUE)
parser$add_argument("--outdir", help='out dir', required=TRUE)
parser$add_argument("--assign_file", help='auto_assign', required=TRUE)
args <- parser$parse_args()

rna <- readRDS(args$rds)
vdj <- read.table(args$VDJ, sep=',', header=T)

cells <- subset(vdj, productive=='True')
barcodes <- unique(cells$barcode)

df <- rna@meta.data
df$barcode <- rownames(df)

filter_df <- filter(df, barcode %in% barcodes)
res <- table(filter_df$seurat_clusters)
res <- as.data.frame(res)

out_csv = stringr::str_glue("{args$outdir}/{args$sample}_match_barcodes_celltypes_distribution.txt")
write_csv(res,file=out_csv)

meta = rna@meta.data
meta$Class = 'NA'
meta[barcodes,'Class'] = 'T/BCR'
rna@meta.data = meta
rna <- RunUMAP(rna, dims = 1:20)

outP = stringr::str_glue("{args$outdir}/{args$sample}_cluster_umap.png")
png(outP, height=1000, width=1000)
UMAPPlot(rna,group.by='seurat_clusters',label=TRUE)
dev.off()

outP1 = stringr::str_glue("{args$outdir}/{args$sample}_umapplot.png")
png(outP1, height=1000, width=1000)
UMAPPlot(rna,group.by='Class',cols=c('grey','red'),label=TRUE)
dev.off()

cell_ident_file <- read.table(args$assign_file,header = TRUE,sep="\t",stringsAsFactors=FALSE)
cell_ident_file <- cell_ident_file %>%
  group_by(cluster) %>%
  filter(avg_pct.diff==max(avg_pct.diff))
current_ident <- cell_ident_file[,1]
new_ident <- cell_ident_file[,2]
new.cluster.ids = (new_ident$cell_type)
Idents(rna) <- "seurat_clusters"
names(new.cluster.ids) <- sort(as.numeric(levels(rna)))
rna <- RenameIdents(rna, new.cluster.ids)
rna <- StashIdent(object = rna, save.name = "CellTypes")

outP2 = stringr::str_glue("{args$outdir}/{args$sample}_assign.png")
png(outP2, height=1000, width=1000)
UMAPPlot(rna,group.by='CellTypes',label=TRUE,label.box=TRUE)
dev.off()

meta = rna@meta.data
outMeta = stringr::str_glue("{args$outdir}/{args$sample}_meta.csv")
write.csv(meta,outMeta)

library(DropletUtils)
library(Seurat)
library(argparser)
library(tidyverse)

argv <- arg_parser('')
argv <- add_argument(argv,"--outdir", help="the output dir.",default=getwd())
argv <- add_argument(argv,"--sample", help="sample")
argv <- add_argument(argv,"--matrix_dir", help="matrix_dir")
argv <- add_argument(argv,"--threshold", help="UMI threshold")
argv <- parse_args(argv)

#read args
outdir = argv$outdir
sample = argv$sample
matrix_dir = argv$matrix_dir
threshold = as.numeric(argv$threshold)

mtx = Seurat::Read10X(matrix_dir)
bcrank = barcodeRanks(mtx, lower=threshold/2)
inflection = as.numeric(bcrank@metadata$inflection)
knee = as.numeric(bcrank@metadata$knee)

origin.cell = sum(bcrank$total >= threshold)
inflection.cell = sum(bcrank$total >= inflection)
rescued.cell = inflection.cell - origin.cell
if (rescued.cell < 0){
    rescued.cell = 0
}
print(paste('rescued cell number:',rescued.cell))

df = tibble(
    inflection=as.character(inflection),
    knee=as.character(knee),
    rescued_cell=as.character(rescued.cell)
)
print(df)
df.out = stringr::str_glue('{outdir}/{sample}_rescue.tsv')
write_tsv(df, df.out)

library(tidyverse)
library(argparser)

argv <- arg_parser('')
argv <- add_argument(argv,"--tsne_fusion", help="tsne_fusion file")
argv <- add_argument(argv,"--outdir", help="output dir")
argv <- parse_args(argv)

tsne_fusion = argv$tsne_fusion
outdir = argv$outdir

df = read_tsv(tsne_fusion)
ncol = dim(df)[2]
cols = colnames(df[,c(6:ncol)])
str = function(x){ifelse(x>0,"Fusion","No Fusion")}
for (col in cols){
    df[col] = apply(df[col],FUN=str,MARGIN=1)
    p = ggplot(df,aes_string(x="tSNE_1",y="tSNE_2",color=col)) + geom_point()
    pdf.name = paste0(outdir,"/",col,"_fusion.pdf")
    pdf(pdf.name,height=10,width=12)
    print (p)
    dev.off()
}

library(Seurat)
library(tidyverse)
library(argparser)

argv <- arg_parser('')
argv <- add_argument(argv,"--citeseq_mtx", help="citeseq_mtx file")
argv <- add_argument(argv,"--outdir", help="outdir")
argv <- add_argument(argv,"--sample", help="sample")
argv <- add_argument(argv,"--rds", help="rds")
argv <- parse_args(argv)

#args
citeseq_mtx = argv$citeseq_mtx
outdir = argv$outdir
sample = argv$sample
rds = argv$rds

rds = readRDS(rds)
rds.adt <- read.csv(citeseq_mtx, sep = "\t", header = TRUE, row.names = 1)
adt_assay <- CreateAssayObject(counts = rds.adt)
rds[["ADT"]] <- adt_assay

# Normalize ADT data,
DefaultAssay(rds) <- "ADT"
rds <- NormalizeData(rds, normalization.method = "CLR", margin = 2)
DefaultAssay(rds) <- "RNA"

# Note that the following command is an alternative but returns the same result
rds <- NormalizeData(rds, normalization.method = "CLR", margin = 2, assay = "ADT")

DefaultAssay(rds) <- "ADT"

pdf.feature = str_glue('{outdir}/{sample}_CITESeq_featurePlot.pdf')
tags = rownames(rds@assays$ADT@data)
n_tags = length(tags)

pdf(pdf.feature, height=n_tags, width=12)
p = FeaturePlot(rds, rownames(rds@assays$ADT@data), ncol=4, pt.size=0.2)
print(p)
dev.off()

pdf.vln = str_glue('{outdir}/{sample}_CITESeq_vlnPlot.pdf')
pdf(pdf.vln, height=n_tags, width=18)
p = VlnPlot(rds, rownames(rds@assays$ADT@data), ncol=4, pt.size=0.2)
print(p)
dev.off()

library(Seurat)
library(tidyverse)
library(argparser)

argv <- arg_parser('')
argv <- add_argument(argv,"--outdir", help="the output dir.",default=getwd())
argv <- add_argument(argv,"--sample", help="sample")
argv <- add_argument(argv,"--umi_tag",help="umi_tag")
argv <- add_argument(argv,"--matrix_10X",help="matrix_10X")
argv <- parse_args(argv)

outdir = argv$outdir
sample = argv$sample
umi_tag = argv$umi_tag
matrix_10X = argv$matrix_10X

df = read.csv(umi_tag, sep='\t', row.names = 1)
counts = Seurat::Read10X(matrix_10X)

df = df[1:length(df)-1]
df = t(df)

rds = CreateSeuratObject(counts = counts)
rds[["HTO"]] <- CreateAssayObject(counts = df)

rds <- NormalizeData(rds, assay = "HTO", normalization.method = "CLR")
rds <- HTODemux(rds, assay = "HTO")

# output
global_class = data.frame(table(rds$HTO_classification.global))
global_class.out = str_glue("{outdir}/{sample}_seurat_global_class.tsv")
write_tsv(global_class, global_class.out, col_names = F)

tag_count = data.frame(table(rds$HTO_classification))
tag_count.out = str_glue("{outdir}/{sample}_seurat_tag_count.tsv")
write_tsv(tag_count, tag_count.out, col_names = F)

tag = data.frame(rds$HTO_classification)
tag.out = str_glue("{outdir}/{sample}_seurat_tag.tsv")
write_tsv(tag, tag.out, col_names = F)

library(Seurat) # v4.0
library(tidyverse)
library(argparser)

# CONSTANTS
DIMS = 20

argv <- arg_parser('')
argv <- add_argument(argv,"--matrix_file", help="cell 10X matrix dir")
argv <- add_argument(argv,"--outdir", help="outdir")
argv <- add_argument(argv,"--sample", help="sample")
argv <- add_argument(argv,"--mt_gene_list", help="write rds to disk")
argv <- add_argument(argv,"--save_rds", help="write rds to disk")
argv <- parse_args(argv)

#args
matrix_file = argv$matrix_file
mt_gene_list = argv$mt_gene_list
outdir = argv$outdir
sample = argv$sample
save_rds = argv$save_rds
resolution = 0.6
res_str = paste0('res.', resolution)

# read matrix
# matrix_id = Seurat::Read10X(matrix_file, gene.column=1)
matrix_name = Seurat::Read10X(matrix_file, gene.column=2)

# out files
tsne.out = stringr::str_glue('{outdir}/{sample}_tsne_coord.tsv')
marker.out = stringr::str_glue('{outdir}/{sample}_markers.tsv')
mito.out = paste(outdir,"stat.txt",sep="/")
rds.out = paste0(outdir,'/',sample,'.rds')

# create seurat obj
rds = CreateSeuratObject(matrix_name, pro=sample)

# mito
all_genes = rownames(rds@assays$RNA@data)
if (mt_gene_list != "None"){
  mito.genes = read.table(mt_gene_list, )[,1]
  mito.genes = intersect(mito.genes, all_genes)
} else {
  mito.genes <- grep(pattern = "^MT-", x = all_genes, value = TRUE, ignore.case=TRUE)
}
print("mito genes exp > 0")
print(mito.genes)

percent.mito <- Matrix::colSums(rds@assays$RNA@counts[mito.genes,,drop=FALSE])/Matrix::colSums(rds@assays$RNA@counts)
rds <- AddMetaData(object = rds, metadata = percent.mito, col.name = "percent.mito")
meta = rds@meta.data
total_cell = dim(meta)[1]
percent_list = c(0.05,0.1,0.15,0.2,0.5)
mito_df = dplyr::tibble(mito_percent=numeric(),cell_percent=numeric())
for (percent in percent_list){
  cell_percent = sum(meta$percent.mito > percent) / total_cell
  mito_df = mito_df %>% dplyr::add_row(mito_percent=percent,cell_percent=cell_percent)
}
paste0(round(mito_df$cell_percent * 100,2),"%")
mito_df$cell_percent = paste0(round(mito_df$cell_percent * 100,2),"%")
mito_df$mito_percent = paste0("Fraction of cells have mito gene percent>",round(mito_df$mito_percent * 100,2),"%")
write_delim(mito_df, mito.out, col_names=F, delim=":")


rds <- NormalizeData(rds, normalization.method = "LogNormalize",scale.factor = 10000)
nfeatures = 20000
rds <- FindVariableFeatures(rds, selection.method = "vst", nfeatures = nfeatures, mean.cutoff = c(0.1, 8), dispersion.cutoff = c(1, Inf),
                            mean.function = ExpMean, dispersion.function = LogVMR)

use.genes <- rds@assays$RNA@var.features
rds <- ScaleData(rds, vars.to.regress = c("nCount_RNA", "percent.mito"), features = use.genes)
rds <- RunPCA(object = rds, features = use.genes, do.print = FALSE)
rds <- FindNeighbors(rds, dims = 1:DIMS, force.recalc = TRUE, reduction = "pca")
rds <- FindClusters(rds, resolution = resolution)

# tsne and umap
rds <- RunTSNE(rds, dims = 1:DIMS, do.fast = TRUE, check_duplicates = FALSE)
rds = RunUMAP(rds, dims=1:DIMS)


tryCatch({
  rds.markers <- FindAllMarkers(object = rds, features = use.genes)
  rds.markers = dplyr::group_by(rds.markers,cluster) %>% dplyr::arrange(desc(avg_log2FC))
}, error = function(e){
  print (paste0("no marker found: ", e))
  rds.markers <<- data.frame(cluster=double(),
                             gene=double(),
                             avg_log2FC=double(),
                             pct.1=double(),
                             pct.2=double(),
                             p_val_adj=double())

})

rds.markers$cluster = as.numeric(rds.markers$cluster)
print (rds.markers)
write_tsv(rds.markers,marker.out,col_names = T)


df.tsne = rds@reductions$tsne@cell.embeddings
df.tsne = as.data.frame(df.tsne)
meta = rds@meta.data
dic = rds@meta.data[['seurat_clusters']]
names(dic) = rownames(rds@meta.data)
df.tsne$cluster = as.numeric(dic[rownames(df.tsne)])
rds@meta.data$seurat_clusters = as.numeric(dic[rownames(df.tsne)])
df.gene = meta[,"nFeature_RNA",drop=F]
colnames(df.gene) = "Gene_Counts"
df.all = cbind(df.tsne,df.gene)
write.table(df.all,tsne.out,sep="\t",col.names=NA,quote = F)


if (save_rds == 'True'){
  saveRDS(rds, rds.out)
}

library(argparser)
library(Seurat)
library(tidyverse)

argv <- arg_parser('')
argv <- add_argument(argv,"--outdir", help="the output dir.",default=getwd())
argv <- add_argument(argv,"--sample", help="sample")
argv <- add_argument(argv,"--rds",help="Seurat rds")
argv <- add_argument(argv,"--type_marker_tsv",help="cell type marker tsv")
#argv <- add_argument(argv,"--resolution", help="tSNE resolution",default=0.8)
argv <- parse_args(argv)

#read args

outdir <- argv$outdir
sample <- argv$sample
rds <- argv$rds
type_marker_tsv <- argv$type_marker_tsv
#resolution <- argv$resolution
rds <- argv$rds
#origin.cluster <- paste("res.",resolution,sep="")

print ("reading RDS")
all_data <- readRDS(rds)
print ("done.")
marker_file <- read_tsv(type_marker_tsv)

#
cell_name <- (marker_file)[,1,drop=T]
n_cell_name <- length(cell_name)

#reset
#all_data <- SetAllIdent(object = all_data, id = origin.cluster)
clusters <- sort(unique(all_data@active.ident))

#create dir
auto_dir <- stringr::str_glue('{outdir}/{sample}_auto_assign/')
png_dir <- stringr::str_glue('{auto_dir}/{sample}_png/')
dir.create(auto_dir)
dir.create(png_dir)

# type marker
c = 0 
for (cluster in clusters){
  index = 0
  for (cell in cell_name){
    index = index + 1
    pos = unlist(strsplit(marker_file[index,2,drop=T],","))
    neg = tryCatch(unlist(strsplit(marker_file[index,3,drop=T],",")) ,error=function(e){} )
    for (F in pos){
      tryCatch({
        dat <- FindMarkers(all_data,feature=F,ident.1=cluster,min.pct = 0,logfc.threshold = -Inf)
        dat$cell_type <- cell
        dat$cluster <- cluster
        dat <- rownames_to_column(dat,var="gene")
        dat$type <- "positive"
        if (c==0){
          all_dat <- dat
          c = c + 1
        } else {
          all_dat <- rbind(all_dat,dat)
          }
        }
        ,error=function(e){print(paste0(F," not found in cluster ",cluster)) })
    }

    if (!is.na(neg) && !is.null(neg)){
    	for (F in neg){
      	tryCatch({
        dat <- FindMarkers(all_data,feature=F,ident.1=cluster,min.pct = 0,logfc.threshold = -Inf)
        dat$cell_type <- cell
        dat$cluster <- cluster
        dat <- rownames_to_column(dat,var="gene")
        dat$type <- "negative"
        if (c==0){
          all_dat <- dat
          c = c + 1
        } else {
          all_dat <- rbind(all_dat,dat)
          }
        }
        ,error=function(e){print(paste0(F," not found in cluster ",cluster)) })
    	}
    }

  }
}

all_dat$cluster <- as.numeric(all_dat$cluster) + 1
all_dat <- mutate(all_dat,pct.diff=pct.1-pct.2)
exp.out = stringr::str_glue('{auto_dir}/{sample}_type_marker_exp.tsv')
write_tsv(all_dat, exp.out)

# plot
color2 <- c("OrangeRed","SlateBlue3","DarkOrange","GreenYellow","Purple",
"DarkSlateGray","Gold","DarkGreen","DeepPink2","Red4",
"#4682B4","#FFDAB9","#708090","#836FFF","#CDC673",
"#CD9B1D","#FF6EB4","#CDB5CD","#008B8B","#43CD80",
"#6A5ACD","#66CD00","#CDC673","#CDAD00","#CD9B9B","#FF8247","#8B7355","#8B3A62",
"#68228B","#CDB7B5","#CD853F","#6B8E23","#E6E6FA","#FFDAB9","Green")

exp <- all_dat
a <- group_by(exp,cluster,cell_type)
for (cluster in clusters){
  c = a[a$cluster==cluster,]

  png(paste0(png_dir,cluster,"_pctdiff.png"),width=1200,height=1000)
  p1 <- ggplot(c,aes(x=interaction(gene,cell_type,type),y=pct.diff,fill=cell_type)) +geom_bar(stat="identity")+ coord_flip() + scale_fill_manual(values=color2)
  print (p1)
  dev.off()

  png(paste0(png_dir,cluster,"_logfc.png"),width=1200,height=1000)
  p2 <- ggplot(c,aes(x=interaction(gene,cell_type,type),avg_log2FC,fill=cell_type)) +geom_bar(stat="identity")+ coord_flip() + scale_fill_manual(values=color2)
  print (p2)
  dev.off()
}

# auto assign
exp[exp$type=="negative",]$avg_log2FC = -(exp[exp$type=="negative",]$avg_log2FC)
exp[exp$type=="negative",]$pct.diff = -(exp[exp$type=="negative",]$pct.diff)
a <- group_by(exp,cluster,cell_type)
as <- summarize(a,avg_pct.diff=mean(pct.diff),avg_log2FC=mean(avg_log2FC),max_p_val_adj=max(p_val_adj))
as1 <- group_by(ungroup(as),cluster)
as1 <- mutate(as1,pct_rank = rank(avg_pct.diff),
              logfc_rank= rank(avg_log2FC),total_rank=pct_rank+logfc_rank)
as2 <- as1 %>% ungroup %>% group_by(cluster) %>% 
  filter(total_rank==max(total_rank)) %>% arrange(as.numeric(cluster))
as3 <- select(as2,cluster,cell_type,avg_pct.diff,avg_log2FC,max_p_val_adj)
as3[(as3$avg_pct.diff < 0 | as3$avg_log2FC < 0),]$cell_type = 'NA'
res.out = stringr::str_glue('{auto_dir}/{sample}_auto_cluster_type.tsv')
write_tsv(as3, res.out)

## Major changes

- Optimize speed and memory usage of step `barcode`(~2X faster) and `celescope.tools.count.downsample`(~15-25X faster, 1/2 memory usage).

- Change filtering of linker from allowing two mismatches in total to two mismatches per segment; this will slightly increase the valid reads percentage.


## Minor changes

- Default output fastq files of `barcode` and `cutadapt` are not gzipped. Use `--gzipped` to get gzipped output.

- Change the display of Barcode-rank plot in html report. 

- Add parameter `--coefficient`  to `celescope tag count_tag` and `multi_tag`
    
    Default `0.1`. Minimum signal-to-noise ratio is calulated as `SNR_min = max(median(SNRs) * coefficient, 2)`

- VDJ merge.xls can display all the metrics correctly.

- Remove fastqc from `barcode` step.

- Add `.metrics.json`

## Bug fix

- Fix a bug that `celescope.tools.barcode.mismatch` cannot output all sequences correctly when n_mismatch>=2.

- Fix an error when Numpy >= 1.2.0.

## Major changes

- Add read consensus to VDJ pipeline.

    A consensus step was added before mapping to merge all the reads of the same (barcode, UMI) into one UMI. For defailed consensus algorithm, refer to `celescope.tools.consensus`.  
    multi_vdj adds the parameter `--not_consensus` that you can skip the consensus step, and get the same results as v1.1.7.

- Add parameter `--species` to `celescope vdj mapping_vdj` and `multi_vdj`.

    `--species` can be one of:
    - `hs`: human
    - `mmu`: mouse


- Add parameter `--cell_calling_method` to `celescope rna count` and `multi_rna`.

    `--cell_calling_method` can be one of:  
    - `auto`: Same result as v1.1.7.  
    - `cellranger3`: Refer to the cell_calling algorithm of cellranger3, and the result is similar to cellranger3.  
    - `reflection`: Use the inflection point of the barcode-rank curve as the UMI threshold. The minimum UMI value is changed from initial threshold / 10 to initial threshold / 2 to prevent the use of a lower inflection point when there are multiple inflection points.  


## Minor changes

- Add 4 tags to featureCounts bam.

    - `CB`: cell barcode
    - `UB`: UMI
    - `GN`: gene name
    - `GX`: gene id

- One sample can have different chemistry fastq in mapfile.  Version <= v1.1.7 will report this as an error.

- Add `--STAR_param` to `celescope rna STAR`

    Additional parameters of STAR can be passed into the `STAR` step.

- Gtf file can be gzipped.

- `multi_rna` can use 3 paramters: `--STAR_index`, `--gtf` and `--refFlat` instead of `--genomeDir` 

- snp analysis use mutract.

# barcode

## Features
- Demultiplex barcodes.
- Filter invalid R1 reads, which includes:
    - Reads without linker: the mismatch between linkers and all linkers in the whitelist is greater than 2.  
    - Reads without correct barcode: the mismatch between barcodes and all barcodes in the whitelist is greater than 1.  
    - Reads without polyT: the number of T bases in the defined polyT region is less than 10.
    - Low quality reads: low sequencing quality in barcode and UMI regions.(`--lowQual` and `--lowNum`)

## Input
- Paired-end FASTQ files.

## Output
- `{sample}_2.fq` Demultiplexed R2 reads. Barcode and UMI are contained in the read name. The format of the read name is `{barcode}_{UMI}_{read ID}`.

- `fastqc.zip` `fastqc.html` Fastqc results.

## Parameters

`--fq1` Required, FASTQ R1 reads. Multiple FASTQ files are seperated by comma. 

`--fq2` Required, FASTQ R2 reads. Multiple FASTQ files are seperated by comma. 

`--chemistry` Predefined (pattern, barcode whitelist, linker whitelist) combinations. Can be one of:  
- `auto` Default value. Used for Singleron GEXSCOPE libraries >= scopeV2 and automatically detects the combinations.  
- `scopeV1` Used for legacy Singleron GEXSCOPE scopeV1 libraries.  
- `customized` Used for user defined combinations. You need to provide `pattern`, `whitelist` and `linker` at the same time.

`--pattern` The pattern of R1 reads, e.g. `C8L16C8L16C8L1U12T18`. The number after the letter represents the number of bases.  
- `C`: cell barcode  
- `L`: linker(common sequences)  
- `U`: UMI    
- `T`: poly T

`--whitelist` Cell barcode whitelist file path, one cell barcode per line.

`--linker` Linker whitelist file path, one linker per line.

`--lowQual` Default `0`. Bases in cell barcode and UMI whose phred value are lower than lowQual will be regarded as low-quality bases.

`--lowNum` Default `2`. The maximum allowed lowQual bases in cell barcode and UMI.

`--nopolyT` Outputs R1 reads without polyT.
    
`--noLinker` Outputs R1 reads without correct linker.

`--allowNoPolyT` Allow reads without polyT.

`--allowNoLinker` Allow reads with incorrect linker.

`--gzip` Output gzipped fastq.

## Metrics
-  Raw Reads: total read pairs from FASTQ files.

-  Valid Reads: reads pass filtering(filtered: reads without poly T, reads without linker, reads without correct barcode or low quality reads).

-  Q30 of Barcodes: percent of barcode base pairs with quality scores over Q30.

-  Q30 of UMIs: percent of UMI base pairs with quality scores over Q30.

# Multi-samples and step-by-step

## Features
- CeleScope contains an interface to run multiple samples, which is `multi_{assay}`.
- Step-by-step analysis.

## Input
- Mapfile. Mapfile is a text file divided by tabs, containing three columns, each line represents a sample.
1st column: Fastq prefix.
2nd column: Folder where fastq is located.
3rd column: {sample} (sample name, which is the prefix of all generated files).
4th column: optional, expected cell number (scRNA-Seq) or match_dir (scVDJ).
Note: When a sample has multiple fastqs, each fastq occupies one line, and the sample name is the same. During processing, these fastqs are treated as the same sample and merged.
	- Example:
	```
	$cat ./my.mapfile
	R2007197	/SGRNJ/DATA_PROJ/2003/20200728	S20071508_D_TS
	R2007198	/SGRNJ/DATA_PROJ/2003/20200728	S20071509_D_TS
	R2007197        /SGRNJ/DATA_PROJ/2003/test      S20071508_D_TS

	$ls -l /SGRNJ/DATA_PROJ/2003/20200728
	-rw-r--r--. 1 download ssh.bioinfo 1.2G Jul 29 00:50 R2007198_L2_2.fq.gz
	-rw-r--r--. 1 download ssh.bioinfo 1.3G Jul 29 00:21 R2007198_L2_1.fq.gz
	-rw-r--r--. 1 download ssh.bioinfo 1.3G Jul 28 23:52 R2007197_L2_2.fq.gz
	-rw-r--r--. 1 download ssh.bioinfo 1.4G Jul 28 23:23 R2007197_L2_1.fq.gz
	```

## Parameters

`--mod` Default `sjm`. Out file mode, `sjm` or `shell`. 

`--mapfile` Required. Mapfile path.

`--rm_files` Remove redundant fq.gz and bam after running.

`--steps_run` Default `all`. Steps to run.

`--outdir` Default `./`. Output dir.

`--debug` Debug or not.

`--thread`  Default `4`. Thread to use.

## Usage
- Multi-sample example(Single Cell RNA-Seq):

	```
	conda activate celescope
	multi_rna\
 	--mapfile ./my.mapfile\
 	--chemistry auto\
 	--genomeDir /SGRNJ/Public/Database/genome/homo_mus\
 	--thread 8\
 	--mod shell
 	```

 - Note: The recommended setting for thread is 8, and the maximum should not exceed 20.

 Scripts above will generate `shell` directory containing `{sample}.sh` file.

 You can start your analysis by running:
 ```
 sh ./shell/S20071508_D_TS.sh
 ```

 - Step-by-step:
 `{sample}.sh` records analysis scripts for each step. You can run these steps respectively. For example:
 ```
 celescope rna STAR --fq .//S20071508_D_TS/02.cutadapt/S20071508_D_TS_clean_2.fq.gz --sample S20071508_D_TS --genomeDir /SGRNJ/Public/Database/genome/homo_sapiens/ensembl_92 --thread 6 --outdir .//S20071508_D_TS/03.STAR --assay rna
 ```
 

# count_vdj

## Features
- Cell calling.
- Calculate clonetypes.

## Input
- `{sample}_UMI_count_filtered1.tsv` from mapping_vdj.

## Output
- `{sample}_cell_confident.tsv` The clone type of VDJ cell barcode, each chain occupies one line.

- `{sample}_cell_confident_count.tsv` The clone type of VDJ cell barcode, each cell occupies one line.

- `{sample}_clonetypes.tsv` The count and percentage of each clonotype of VDJ cell barcode.

- `{sample}_match_clonetypes.tsv` The count and percentage of each clonotype at the intersection of VDJ cell barcode and sc-RNA-Seq cell barcode. The file will only be produced when the match_dir parameter is provided.

## Parameters

`--type` Required. `TCR` or `BCR`.

`--UMI_count_filter1_file` Required. File from step mapping_vdj.

`--match_dir` Default `None`. CeleScope rna analysis path. 

`--UMI_min` Default `auto`. Minimum UMI number to filter. The barcode with UMI>=UMI_min is considered to be cell.

`--iUMI` Default `1`. Minimum number of UMI of identical receptor type and CDR3. For each (barcode, chain) combination, only UMI>=iUMI is considered confident. 

## Metrics
- Estimated Number of cells : number of barcodes considered as cell-associated.

- Median UMIs per Cell : median number of UMI mapped to each chain per cell.

- Cell with Heavy and Light Chain : cells with as least 5 UMI mapped to each chain.

- Cell with Barcode Match : cells with barcode matched with scRNA-seq library.

- Cell with barcode Match, Heavy and Light chain : cell with matched barcode and with as least 5 UMI mapped to each chain.

# count

## Features
- Cell-calling: Distinguish cell barcodes from background barcodes. 
- Generate expression matrix.

## Input
- BAM file from step featureCounts.

## Output
- `{sample}_all_matrix` The expression matrix of all detected barcodes. Can be read in by calling the `Seurat::Read10X` function.

- `{sample}_matrix_10X` The expression matrix of the barcode that is identified to be the cell. Can be read in by calling the `Seurat::Read10X` function.

- `{sample}_matrix.tsv.gz` The expression matrix of the barcode that is identified to be the cell, separated by tabs.

- `{sample}_count_detail.txt.gz` 4 columns: 
	- barcode  
	- gene ID  
	- UMI count  
	- read_count  

- `{sample}_counts.txt` 6 columns:
	- Barcode: barcode sequence
	- readcount: reads num of each barcode
	- UMI2: UMI num (reads >= 2) for each barcode
	- UMI: UMI num for each barcode
	- geneID: Gene num for each barcode
	- mark UB: background CB: cell

- `{sample}_downsample.txt` 3 columns：
	- percent: percentage of sampled reads
	- median_geneNum: median gene number per cell
	- saturation: sequencing saturation

- `barcode_filter_magnitude.pdf` Barcode-UMI plot.

## Parameters

`--bam` Required. BAM file from featureCounts.

`--genomeDir` Required. Directory contains genome Fasta, GTF and refFLAT file. If this argument is not provided, you need to provide `--gtf`.

`--gtf` GTF file path.

`--expected_cell_num` Default `3000`. Expected cell number.

`--cell_calling_method` Default `auto`. Cell calling methods.Choose from `auto`, `cellranger3` and `inflection`.

`--force_cell_num` Default `None`. Force the cell number to be this value ± 10%.

## Metrics
- Estimated Number of Cells : the number of barcodes considered as cell-associated.

- Fraction Reads in Cells : the fraction of uniquely-mapped-to-transcriptome reads with cell-associated barcodes.

- Mean Reads per Cell : the number of valid reads divided by the estimated number of cells.

- Median UMI per Cell : the median number of UMI counts per cell-associated barcode.

- Total Genes : the number of genes with at least one UMI count in any cell.

- Median Genes per Cell : the median number of genes detected per cell-associated barcode.

- Saturation : the fraction of UMI originating from an already-observed UMI.

# featureCounts

## Features
- Assigning uniquely mapped reads to genomic features with FeatureCounts.

## Input
- BAM file from step STAR.

## Output
- `{sample}` Numbers of reads assigned to features (or meta-features).

- `{sample}_summary` Stat info for the overall summrization results, including number of successfully assigned reads and number of reads that failed to be assigned due to various reasons (these reasons are included in the stat info).

- `{sample}_Aligned.sortedByCoord.out.bam.featureCounts.bam` featureCounts output BAM, sorted by coordinates；BAM file contains tags as following(Software Version>=1.1.8):
    - CB cell barcode
    - UB UMI
    - GN gene name
    - GX gene id

- `{sample}_name_sorted.bam` featureCounts output BAM, sorted by read name.

## Parameters

`--input` Required. BAM file path.

`--genomeDir` Required. Directory contains genome Fasta, GTF and refFLAT file. If this argument is not provided, you need to provide `--gtf`.

`--gtf_type` Default `exon`. Single-nuclei RNA-seq uses `gene`. Specified feature type in GTF.

`--gtf` gtf file path.

## Metrics
- Assigned : reads that can be successfully assigned without ambiguity.

- Unassigned_NoFeatures : alignments that do not overlap any feature.

- Unassigned_Ambiguity : alignments that overlap two or more features.

# cutadapt

## Features
- Trim adapters in R2 reads with cutadapt. Default adapters includes:
	- polyT=A{18}, 18 A bases. 
	- p5=AGATCGGAAGAGCACACGTCTGAACTCCAGTCA, Illumina p5 adapter.

## Input
- R2 reads from step Barcode.

## Output
- `cutadapt.log` cutadapt output log file.

- `{sample}_clean_2.fq.gz` R2 reads file without adapters.

## Parameters

`--fq` R2 reads from step Barcode. Required. 

`--adapter_fasta` Addtional adapter Fasta file.

`--minimum_length` Default `20`. Discard processed reads that are shorter than LENGTH.

`--nextseq_trim` Default `20`. Quality trimming of reads using two-color chemistry (NextSeq). Some Illumina instruments use a two-color chemistry to encode the four bases. This includes the NextSeq and the NovaSeq. In those instruments, a ‘dark cycle’ (with no detected color) encodes a G. However, dark cycles also occur when sequencing “falls off” the end of the fragment. The read then contains a run of high-quality, but incorrect “G” calls at its 3’ end.

Since the regular quality-trimming algorithm cannot deal with this situation, you need to use the `--nextseq-trim` option: `cutadapt --nextseq-trim=20 -o out.fastq input.fastq`
This works like regular quality trimming (where one would use `-q 20` instead), except that the qualities of G bases are ignored.

`--overlap` Default `10`. Since Cutadapt allows partial matches between the read and the adapter sequence, short matches can occur by chance, leading to erroneously trimmed bases. For example, roughly 25% of all reads end with a base that is identical to the first base of the adapter. To reduce the number of falsely trimmed bases, the alignment algorithm requires that, by default, at least three bases match between adapter and read. This minimum overlap length can be changed globally (for all adapters) with the parameter `--overlap` (or its short version `-O`).

`--insert` Default `150`. Read2 insert length. To shorten each read down to a certain length, use the `--length` option or the short version `-l`.

`--gzip` Output gzipped fastq.

## Metrics
- Reads with Adapters : reads with sequencing adapters or reads two with poly A(read-through adpaters).

- Reads too Short : reads with read length less than 20bp after trimming.

- Reads Written : reads pass filtering.

- Base Pairs Processed : total processed base pairs.

- Base Pairs Quality-Trimmed : bases pairs removed from the end of the read whose quality is smaller than the given threshold.

- Base Pairs Written : base pairs pass filtering.

# consensus

## Features
- Consensus all the reads of the same (barcode, UMI) combinations into one read(UMI).

## Input
- R2 Fastq.

## Output
- Consensus fastq.

## Parameters

`--fq` Required. R2 reads from step cutadapt.

`--threshold` Default `0.5`. Valid base threshold.

`--not_consensus` Skip the consensus step.

## Metrics

- UMI Counts: Total UMIs number after consensus.

- Mean UMI Length: Mean UMI length after consensus.

- Ambiguous Base Counts: Total ambiguous bases number.

# analysis

## Features
- Cell clustering with Seurat.
- Calculate the marker gene of each cluster.
- Cell type annotation(optional). You can provide markers of known cell types and annotate cell types for each cluster.

## Input
- gene expression matrix from step Count.
- Cell type markers(optional).

## Output
- `markers.tsv` Marker genes of each cluster.

- `tsne_coord.tsv` t-SNE coordinates and clustering information.

- `{sample}/06.analsis/{sample}_auto_assign/` This result will only be obtained when `--type_marker_tsv` parameter is provided. The result contains 3 files:
	- `{sample}_auto_cluster_type.tsv` The cell type of each cluster; if cell_type is "NA", it means that the given marker is not enough to identify the cluster.
	- `{sample}_png/{cluster}_pctdiff.png` Percentage of marker gene expression in this cluster - percentage in all other clusters.
	- `{sample}_png/{cluster}_logfc.png` log2 (average expression of marker gene in this cluster / average expression in all other clusters + 1)

## Paramaters

`--matrix_file count` Required. {sample}_matrix.tsv.gz from step count.

`--save_rds` Save RDS file.

`--type_marker_tsv` A tsv file with header. If this parameter is provided, cell type will be annotated. Example:

```
cell_type	marker
Alveolar	"CLDN18,FOLR1,AQP4,PEBP4"
Endothelial	"CLDN5,FLT1,CDH5,RAMP2"
Epithelial	"CAPS,TMEM190,PIFO,SNTN"
Fibroblast	"COL1A1,DCN,COL1A2,C1R"
B_cell	"CD79A,IGKC,IGLC3,IGHG3"
Myeloid	"LYZ,MARCO,FCGR3A"
T_cell	"CD3D,TRBC1,TRBC2,TRAC"
Mast_cell	"KIT,GATA2"
Langerhans_cells	"CD207,FCER1A"
LUAD	"NKX2-1,NAPSA,EPCAM"
LUSC	"TP63,KRT5,KRT6A,KRT6B,EPCAM"
```

## Metrics
- Top Marker Genes by Cluster : differential expression analysis based on the non-parameteric Wilcoxon rank sum test.

- avg_logFC : log fold-change of the average expression between the cluster and the rest of the sample.

- pct.1 : The percentage of cells where the gene is detected in the cluster.

- pct.2 : The percentage of cells where the gene is detected in the rest of the sample.

- p_val_adj : Adjusted p-value, based on bonferroni correction using all genes in the dataset.

# mapping_vdj

## Features
- Align R2 reads to IGMT(http://www.imgt.org/) database sequences with mixcr.

## Input
- R2 reads from step cutadapt.

## Output
- `{sample}_consensus.fasta` Fasta file after UMI consensus.

- `{sample}_UMI_count_unfiltered.tsv` UMI reading for each (barcode, chain, VJ_pair) combination.

- `{sample}_UMI_count_filtered1.tsv` For each (barcode, chain) combination, only the record with the most VJ_pair UMI reads is kept.

- `{sample}_align.txt` Result report.

- `{sample}_alignments.txt` The alignment result of each UMI/read.

## Parameters

`--fq` Required. R2 reads from step cutadapt. 

`--type` Required. `TCR` or `BCR`.

`--species` Default `hs`. `hs` or `mmu`.


## Metrics
If '--not_consensus' argument was used, Reads were used instead of UMIs.

- UMIs(or Reads) Mapped to Any VDJ Gene : UMIs(or Reads) Mapped to any germline VDJ gene segments.

- UMIs(or Reads) with CDR3 : UMIs(or Reads) with CDR3 sequence.

- UMIs(or Reads) with Correct CDR3 : some UMIs(or Reads) with CDR3 might have stop codon and these UMIs(or Reads) are classified as incorrect.

- UMIs(or Reads) Mapped Confidently to VJ Gene : UMIs(or Reads) mapped to VJ gene pairs and with correct CDR3.

- UMIs(or Reads) Mapped to IGH : UMIs(or Reads) mapped confidently to IGH chain.

- UMIs(or Reads) Mapped to IGL : UMIs(or Reads) mapped confidently to IGL chain.

- UMIs(or Reads) Mapped to IGK : UMIs(or Reads) mapped confidently to IGK chain.

# STAR

## Features
- Align R2 reads to the reference genome with STAR.
- Collect Metrics with Picard.

## Input
- R2 clean reads from step cutadapt.

## Output
- `{sample}_Aligned.sortedByCoord.out.bam` BAM file contains Uniquely Mapped Reads.

- `{sample}_SJ.out.tab` SJ.out.tab contains high confidence collapsed splice junctions in tab-delimited format.

- `{sample}_Log.out` Main log with a lot of detailed information about the run. This is most useful for troubleshooting and debugging.

- `{sample}_Log.progress.out` Report job progress statistics, such as the number of processed reads, % of mapped reads etc. It is updated in 1 minute intervals.

- `{sample}_Log.Log.final.out` Summary mapping statistics after mapping job is complete, very useful for quality control. The statistics are calculated for each read (single- or paired-end) and then summed or averaged over all reads. Note that STAR counts a paired-end read as one read, (unlike the samtools agstat/idxstats, which count each mate separately). Most of the information is collected about the UNIQUE mappers (unlike samtools agstat/idxstats which does not separate unique or multi-mappers). Each splicing is counted in the numbers of splices, which would correspond to summing the counts in SJ.out.tab. The mismatch/indel error rates are calculated on a per base basis, i.e. as total number of mismatches/indels in all unique mappers divided by the total number of mapped bases.

- `{sample}_region.log` Picard CollectRnaSeqMetrics results.

## Parameters

`--fq` Required. R2 reads from step cutadapt.

`--genomeDir` Directory contains genome Fasta, GTF and refFLAT file. If this argument is not provided, you need to provide `--STAR_index` and `--refFlat`

`--STAR_index` STAR index directory path.

`--refFlat` refFlat file path.

`--starMem` Default `30`. Maximum memory that STAR can use.

`--out_unmapped` will output unmapped and partially mapped (i.e. mapped only one
mate of a paired end read) reads into separate Unmapped.out.mate1(2), formatted the same
way as input read (i.e. FASTQ or FASTA).

`--outFilterMultimapNmax` Default `1`. How many places are allowed to match a read at most.

`--outFilterMatchNmin` Default `0`. Alignment will be output only if the number of matched bases is higher than or equal to this value.

`--STAR_param` Default `''`. Other STAR parameters.

## Metrics
- Uniquely Mapped Reads: reads that mapped uniquely to the genome.

- Multi-Mapped Reads: reads that mapped to multiple locations in the genome.

- Base Pairs Mapped to Exonic Regions: bases in primary alignments that align to a coding base or a UTR base for some gene.

- Base Pairs Mapped to Intronic Regions: bases in primary alignments that align to an intronic base for some gene, and not a coding or UTR base.

- Base Pairs Mapped to Intergenic Regions: bases in primary alignments that do not align to any gene.
